class User:
    table_name = 'users'    # 类属性

    def __init__(self):
        self.username = 'qiang'     # 实例变量
        self.password = '123456'
        self.email = 'qiang@woniuxy.com'

    def method(self, value):
        print("Hello %s" % value)

    # 链式操作
    def chain(self):
        print("通过返回当前类的实例进行连续的方法调用")
        return self

    def hello(self):
        print("Hello in Chain")
        return self


if __name__ == '__main__':
    user = User()   # 实例化User类
    print(User.__dict__)    # 通过类名可以直接获取到类的属性和方法列表
    print(user.__class__)   # 通过实例可以获取到对应的类
    print(user.__class__.__dict__)

    # 通过 __来区分哪些是自定义的属性和方法
    for k, v in User.__dict__.items():
        if not k.startswith('__'):
            print(k, v)

    print(User.__name__)

    print(user.__dict__)    # 获取实例变量或属性

    user.nickname = '强哥'  # 动态为实例设置属性
    print(user.__dict__)

    user.__setattr__('nickname', '强哥')     # 动态为实例设置属性
    print(user.__dict__)

    setattr(user, 'nickname2', '蜗牛')
    print(user.__dict__)


    print(user.__getattribute__('nickname'))

    print(user.__getattribute__('method'))
    user.__getattribute__('method')('成都')

    getattr(user, 'method')('北京')

    # 链式调用
    user.chain().chain().chain().hello().chain().hello().chain().hello()

