from flask import Blueprint, render_template, session

jinja2 = Blueprint('jinja2', __name__)

# 自定义一个函数，供Jinja2调用
# 第一种文案，使用上下文处理器来注册自定义函数到Jinja2模板引擎中，并且返回一个字典类型的数据
# @jinja2.context_processor
# def gettype_01():
#     type = {'1':'PHP开发', '2':'Java开发', '3':'Python开发'}
#     return dict(mytype=type)

# 如果要为自定义函数传参，则需要使用二层闭包进行包裹
# @jinja2.context_processor
# def myfunc():
#     def mytype(arg):
#         type = {'1': 'PHP开发', '2': 'Java开发', '3': 'Python开发'}
#         return type
#     return dict(mytype=mytype)

# {{mytype(100)}}


@jinja2.route('/jinja2')
def jinja2_demo():
    session['username'] = '蜗牛笔记'
    article = {'title': 'Flask实战教程', 'count': 100}
    content = '<font color="red">这是一段红色的文字</font>'
    return render_template('jinja2-demo.html', article=article, count=100, content=content)

@jinja2.route('/book')
def book():
    books = [
        {'id': 1, 'title': 'PHP教程', 'author': '张三', 'price': 52},
        {'id': 2, 'title': 'Python教程', 'author': '李四', 'price': 36},
        {'id': 3, 'title': 'Java教程', 'author': '王五', 'price': 68}
    ]
    return render_template('books.html', books=books)

