from flask import Blueprint

myhtml = Blueprint('myhtml', __name__)

# 直接将HTML写到代码中，并返回
@myhtml.route('/template01')
def template01():
    resp = '''
    <div style="width: 500px; height: 300px; margin:auto; border: solid 2px red;">
        <a href="#">蜗牛笔记</a>
        <ul>
            <li>这是菜单项一</li>
            <li>这是菜单项二</li>
            <li>这是菜单项三</li>
            <li>这是菜单项四</li>
        </ul>
        <p>欢迎登录.</p>
    </div>
    '''
    return resp

# 直接将变量和HTML进行拼接，再写入响应
@myhtml.route('/template02/<username>')
def template02(username):
    # username = '蜗牛学院'
    resp = '''
    <div style="width: 500px; height: 300px; margin:auto; border: solid 2px red;">
        <a href="#">蜗牛笔记</a>
        <ul>
            <li>这是菜单项一</li>
            <li>这是菜单项二</li>
            <li>这是菜单项三</li>
            <li>这是菜单项四</li>
        </ul>
        <p>欢迎 %s 登录.</p>
    </div>
    ''' % username
    return resp

# 把HTML内容保存到文件中，打开该文件并响应
@myhtml.route('/template03')
def template03():
    with open('template/myhtml.html', encoding='utf-8') as file:
        html = file.read()

    return html

# 在HTML文件中标识模板变量，然后在渲染前对模板变量的值进行替换
# 实现了Python代码与HTML模板页面分离
@myhtml.route('/template04')
def template04():
    with open('template/myhtml.html', encoding='utf-8') as file:
        html = file.read()

    html = html.replace('{{username}}', '蜗牛笔记')

    return html