from flask import Flask, abort
import os
from flask_sqlalchemy import SQLAlchemy
import pymysql
pymysql.install_as_MySQLdb()    # ModuleNotFoundError: No module named 'MySQLdb'

app = Flask(__name__, template_folder='template', static_url_path='/', static_folder='resource')
app.config['SECRET_KEY'] = os.urandom(24)

# 使用集成方式处理SQLAlchemy
app.config['SQLALCHEMY_DATABASE_URI'] = 'mysql://root:123456@localhost:3306/woniunote?charset=utf8'
app.config['SQLALCHEMY_TRACK_MODIFICATIONS'] = False  # True: 跟踪数据库的修改，及时发送信号
# 实例化db对象
db = SQLAlchemy(app)

# 第二种方式：按照标准的函数调用的方式进行
def gettype_02():
    type = {'1': 'PHP开发', '2': 'Java开发', '3': 'Python开发'}
    return type
app.jinja_env.globals.update(mytype=gettype_02)

# 自定义模板页面的过滤器
def mylen(str):
    return len(str)
app.jinja_env.filters.update(mylen=mylen)

@app.route('/')
def index():
    # return render_template('index-base.html')
    return render_template('article-base.html')

# 定义404错误页面
@app.errorhandler(404)
def page_not_found(e):
    return render_template('error-404.html')

# 定义500错误页面
@app.errorhandler(500)
def server_error(e):
    return render_template('error-500.html')

@app.route('/error')
def error_500():
    try:
        x = 10 / 0
        return x
    except:
        return abort(500)

if __name__ == '__main__':
    from controller.myhtml import *
    app.register_blueprint(myhtml)

    from controller.jinja2 import *
    app.register_blueprint(jinja2)

    from controller.user import *
    app.register_blueprint(user)

    app.run(debug=True)
